searchNodes=[{"doc":"The SecureX mix task to create migrations into your project priv/repo/migrations folder","ref":"Mix.Tasks.SecureX.Gen.Migrate.html","title":"Mix.Tasks.SecureX.Gen.Migrate","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.SecureX.Gen.Migrate.html#run/1","title":"Mix.Tasks.SecureX.Gen.Migrate.run/1","type":"function"},{"doc":"SecureX is an Elixir Library to handle your RBAC (Role Based Access Control). It has 4 basic modules, SecureX.Roles , SecureX.Res , SecureX.Permissions and SecureX.UserRoles . All Modules have CRUD to maintain your RBAC. SecureX Module has validation for user. Installation If installing from Hex, use the latest version from there: # mix.ex def deps do [ { :securex , &quot;~&gt; 0.3.0&quot; } ] end Now You need to add configuration for securex in your config/config.ex You need to add Your Repo and User Schema in config. # config/config.exs config :securex , repo : MyApp.Repo , schema : MyApp.Schema.User SecureX comes with built-in support for apps. Just create migrations with mix secure_x.gen.migrate . iex&gt; mix secure_x . gen . migrate * creating priv / repo / migrations * creating priv / repo / migrations / 20211112222439 _create_table_roles . exs * creating priv / repo / migrations / 20211112222439 _create_table_resources . exs * creating priv / repo / migrations / 20211112222439 _create_table_permissions . exs * creating priv / repo / migrations / 20211112222439 _create_table_user_roles . exs The Migrations added to your project. iex&gt; &quot;Do you want to run this migration?&quot; iex&gt; mix ecto . migrate You are Now Up and Running!!! Guide You can also use SecureX as a Middleware. Valid inputs for permissions are &quot;POST&quot;,&quot;GET&quot;,&quot;PUT&quot; ,&quot;DELETE&quot;,&quot;read&quot;,&quot;write&quot;,&quot;delete&quot;,&quot;edit&quot; as well. Permissions have downward flow. i.e if you have defined permissions for a higher operation, It automatically assigns them permissions for lower operations. like &quot;edit&quot; grants permissions for all operations. their hierarchy is in this order. &quot;read&quot; &lt; &quot;write&quot; &lt; &quot;delete&quot; &lt; &quot;edit&quot; &quot;GET&quot; &lt; &quot;POST&quot; &lt; &quot;DELETE&quot; &lt; &quot;PUT&quot; 1 &lt; 2 &lt; 3 &lt; 4 Middlewares In RestApi or GraphiQL all you have to do, add a Plug . Examples #lib/plugs/securex_plug.ex defmodule MyApp.Plugs.SecureXPlug do @behaviour Plug import Plug.Conn def init ( default ) , do : default def call ( conn , _ ) do with [ &quot;Bearer &quot; &lt;&gt; token ] &lt;- get_req_header ( conn , &quot;authorization&quot; ) , { :ok , claims } &lt;- MyApp.Auth.Guardian . decode_and_verify ( token ) , { :ok , user } &lt;- MyApp.Auth.Guardian . resource_from_claims ( claims ) , { :ok , % Plug.Conn { } } &lt;- check_permissions ( conn , user ) do conn else { :error , error } -&gt; conn |&gt; put_resp_content_type ( &quot;application/json&quot; ) |&gt; send_resp ( 403 , Jason . encode! ( %{ errors : error } ) ) |&gt; Plug.Conn . halt ( ) _ -&gt; conn |&gt; put_resp_content_type ( &quot;application/json&quot; ) |&gt; send_resp ( 403 , Jason . encode! ( %{ errors : [ &quot;Permission Denied&quot; ] } ) ) |&gt; Plug.Conn . halt ( ) end end defp check_permissions ( %{ body_params : %{ &quot;resource&quot; =&gt; res , &quot;permission&quot; =&gt; permission } } = conn , %{ id : user_id } ) do case SecureX . has_access? ( user_id , res , permission ) do false -&gt; { :error , false } true -&gt; { :ok , conn } end end defp check_permissions ( _ , _ ) , do : { :error , [ &quot;Invalid Request&quot; ] } end You are all set. Please let us know about and open issue on https://github.com/DevWasi/secruex/issues Looking Forward to it. Happy Coding !!!!!","ref":"SecureX.html","title":"SecureX","type":"module"},{"doc":"Check if user has access. Examples iex&gt; has_access? ( 1 , &quot;users&quot; , &quot;write&quot; ) true iex&gt; has_access? ( 1 , &quot;Gibberish&quot; , &quot;bad_input&quot; ) false","ref":"SecureX.html#has_access?/3","title":"SecureX.has_access?/3","type":"function"},{"doc":"Contains CRUD For Permissions.","ref":"SecureX.Permissions.html","title":"SecureX.Permissions","type":"module"},{"doc":"Add a Permission. You can send either Atom Map or String Map to add Permission. Examples iex&gt; add ( %{ &quot;permission&quot; =&gt; - 1 , &quot;resource_id&quot; =&gt; &quot;users&quot; , &quot;role_id&quot; =&gt; &quot;super_admin&quot; } ) % Permission { id : 1 , permission : - 1 , resource_id : &quot;users&quot; , role_id : &quot;super_admin&quot; }","ref":"SecureX.Permissions.html#add/1","title":"SecureX.Permissions.add/1","type":"function"},{"doc":"Delete a Permission. Examples iex&gt; delete ( % { &quot;id&quot; =&gt; 1 ) % Permission { id : 1 , permission : 4 , resource_id : &quot;users&quot; , role_id : &quot;admin&quot; }","ref":"SecureX.Permissions.html#delete/1","title":"SecureX.Permissions.delete/1","type":"function"},{"doc":"Get list of Permissions by User Roles Examples iex&gt; list ( [ &quot;owner&quot; , &quot;super_admin&quot; ] ) [ ... %{ permission : 4 , resource_id : &quot;users&quot; , role_id : &quot;admin&quot; } , ... %{ permission : 4 , resource_id : &quot;person_form&quot; , role_id : &quot;super_admin&quot; } , ... ]9","ref":"SecureX.Permissions.html#list/1","title":"SecureX.Permissions.list/1","type":"function"},{"doc":"Update a Permission. You can send either Atom Map or String Map to update Permission. ## Examples iex&gt; update ( %{ &quot;id&quot; =&gt; &quot;1&quot; , &quot;resource_id&quot; =&gt; &quot;users&quot; , &quot;permission&quot; =&gt; 4 , &quot;role_id&quot; =&gt; &quot;admin&quot; } ) % Permission { id : 1 , permission : 4 , resource_id : &quot;users&quot; , role_id : &quot;admin&quot; }","ref":"SecureX.Permissions.html#update/1","title":"SecureX.Permissions.update/1","type":"function"},{"doc":"Contains CRUD For Resources.","ref":"SecureX.Res.html","title":"SecureX.Res","type":"module"},{"doc":"Add a Resource. You can send either Atom Map or String Map to add Resource. Examples iex&gt; add ( %{ &quot;res&quot; =&gt; &quot;Person Farm&quot; } ) % Resource { id : &quot;person_farm&quot; , name : &quot;Persons Farm&quot; }","ref":"SecureX.Res.html#add/1","title":"SecureX.Res.add/1","type":"function"},{"doc":"Delete a Resource. All Permissions will be removed against this resource. Examples iex&gt; delete ( % { &quot;id&quot; =&gt; &quot;person_organization&quot; ) % Resource { id : &quot;person_organization&quot; , name : &quot;Person Organization&quot; , permissions : :successfully_removed_permissions }","ref":"SecureX.Res.html#delete/1","title":"SecureX.Res.delete/1","type":"function"},{"doc":"Get a Resource, Examples iex&gt; get ( %{ &quot;res&quot; =&gt; &quot;person_farm&quot; } ) % Resource { id : &quot;person_farm&quot; , name : &quot;Persons Farm&quot; }","ref":"SecureX.Res.html#get/1","title":"SecureX.Res.get/1","type":"function"},{"doc":"Get list of Resources. Examples iex&gt; list ( ) [ % Resource { id : &quot;person_farm&quot; , name : &quot;Persons Farm&quot; } , % Resource { id : &quot;users&quot; , name : &quot;Users&quot; } , ... ]","ref":"SecureX.Res.html#list/0","title":"SecureX.Res.list/0","type":"function"},{"doc":"Update a Resource. You can update any resource along with its permissions. You can send either Atom Map or String Map to update Role. It will automatically update resource_id in Permissions table. Examples iex&gt; update ( %{ &quot;id&quot; =&gt; &quot;person_farm&quot; , &quot;name&quot; =&gt; &quot;Person Organization&quot; } ) % Resource { id : &quot;person_organization&quot; , name : &quot;Person Organization&quot; , permissions : :successfully_updated_permissions }","ref":"SecureX.Res.html#update/1","title":"SecureX.Res.update/1","type":"function"},{"doc":"Contains CRUD For Roles.","ref":"SecureX.Roles.html","title":"SecureX.Roles","type":"module"},{"doc":"Add a Role. You can send either Atom Map or String Map to add Role. If you have existing resources, it will create default permissions against this role Examples iex&gt; add ( %{ &quot;role&quot; =&gt; &quot;Super Admin&quot; } ) % Role { id : &quot;super_admin&quot; , name : &quot;Super Admin&quot; , permission : [ %{ resource_id : &quot;users&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;employees&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;customer&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } ] } Your will get Role struct() with all permissions created for the resources if they exist. list() of permissions you will get in simple map() .","ref":"SecureX.Roles.html#add/1","title":"SecureX.Roles.add/1","type":"function"},{"doc":"Delete a Role. All Permissions and UserRoles will be removed against this role. Examples iex&gt; delete ( % { &quot;id&quot; =&gt; &quot;admin&quot; ) % Role { id : admin , name : &quot;Admin&quot; , permissions : :successfully_removed_permissions , user_roles : :successfully_removed_user_roles }","ref":"SecureX.Roles.html#delete/1","title":"SecureX.Roles.delete/1","type":"function"},{"doc":"Get a Role. Examples iex&gt; get ( %{ &quot;role&quot; =&gt; &quot;super_admin&quot; } ) % Role { id : &quot;super_admin&quot; , name : &quot;Super Admin&quot; , permission : [ ... %{ resource_id : &quot;users&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;employees&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;customer&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } ... ] }","ref":"SecureX.Roles.html#get/1","title":"SecureX.Roles.get/1","type":"function"},{"doc":"Get list of Roles with Permissions. Examples iex&gt; list ( ) [ % Role { id : &quot;super_admin&quot; , name : &quot;Super Admin&quot; , permission : [ ... %{ resource_id : &quot;users&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;employees&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } , %{ resource_id : &quot;customer&quot; , permission : - 1 , role_id : &quot;super_admin&quot; } ... ] } ]","ref":"SecureX.Roles.html#list/0","title":"SecureX.Roles.list/0","type":"function"},{"doc":"Update a Role. You can update any role along with its permissions if you want, if you pass :permissions in your params. You can send either Atom Map or String Map to update Role. It will automatically update that role_id in UserRoles and Permissions table, if you intend to update any role. Examples iex&gt; update ( %{ &quot;id&quot; =&gt; &quot;super_admin&quot; , &quot;role&quot; =&gt; &quot;Admin&quot; , &quot;permissions&quot; =&gt; [ %{ &quot;resource_id&quot; =&gt; &quot;users&quot; , &quot;permission&quot; =&gt; 4 } ] } ) % Role { id : admin , name : &quot;Admin&quot; , permission : [ %{ resource_id : &quot;users&quot; , permission : 4 , role_id : &quot;admin&quot; } ] } It will return with permissions that you sent in params to change.","ref":"SecureX.Roles.html#update/1","title":"SecureX.Roles.update/1","type":"function"},{"doc":"Contains CRUD For UserRoles.","ref":"SecureX.UserRoles.html","title":"SecureX.UserRoles","type":"module"},{"doc":"Add an UserRole. You can send either Atom Map or String Map to add UserRole. Examples iex&gt; create ( %{ &quot;user_id&quot; =&gt; 1 , &quot;role_id&quot; =&gt; &quot;super_admin&quot; } ) % UserRole { id : 1 , user_id : 1 , role_id : &quot;super_admin&quot; }","ref":"SecureX.UserRoles.html#add/1","title":"SecureX.UserRoles.add/1","type":"function"},{"doc":"Delete an UserRole. Examples iex&gt; delete ( % { &quot;id&quot; =&gt; 1 ) % Permission { id : 1 , user_id : 1 , role_id : &quot;admin&quot; }","ref":"SecureX.UserRoles.html#delete/1","title":"SecureX.UserRoles.delete/1","type":"function"},{"doc":"Get list Of UserRoles by user_id , Examples iex&gt; get ( %{ &quot;user_id&quot; =&gt; 1 } ) [ % UserRole { role_id : &quot;admin&quot; , user_id : 1 } , % UserRole { role_id : &quot;super_admin&quot; , user_id : 1 } ]","ref":"SecureX.UserRoles.html#get/1","title":"SecureX.UserRoles.get/1","type":"function"},{"doc":"SecureX is an Elixir Library to handle your RBAC (Role Based Access Control). It has 4 basic modules, SecureX.Roles , SecureX.Res , SecureX.Permissions and SecureX.UserRoles . All Modules have CRUD to maintain your RBAC. SecureX Module has validation for user.","ref":"readme.html","title":"SecureX","type":"extras"},{"doc":"If installing from Hex, use the latest version from there: # mix.ex def deps do [ { :securex , &quot;~&gt; 0.3.0&quot; } ] end Now You need to add configuration for securex in your config/config.ex You need to add Your Repo and User Schema in config. # config/config.exs config :securex , repo : MyApp.Repo , schema : MyApp.Schema.User SecureX comes with built-in support for apps. Just create migrations with mix secure_x.gen.migrate . iex&gt; mix secure_x . gen . migrate * creating priv / repo / migrations * creating priv / repo / migrations / 20211112222439 _create_table_roles . exs * creating priv / repo / migrations / 20211112222439 _create_table_resources . exs * creating priv / repo / migrations / 20211112222439 _create_table_permissions . exs * creating priv / repo / migrations / 20211112222439 _create_table_user_roles . exs The Migrations added to your project. iex&gt; &quot;Do you want to run this migration?&quot; iex&gt; mix ecto . migrate You are Now Up and Running!!!","ref":"readme.html#installation","title":"SecureX - Installation","type":"extras"},{"doc":"You can also use SecureX as a Middleware. Valid inputs for permissions are &quot;POST&quot;,&quot;GET&quot;,&quot;PUT&quot; ,&quot;DELETE&quot;,&quot;read&quot;,&quot;write&quot;,&quot;delete&quot;,&quot;edit&quot; as well. Permissions have downward flow. i.e if you have defined permissions for a higher operation, It automatically assigns them permissions for lower operations. like &quot;edit&quot; grants permissions for all operations. their hierarchy is in this order. &quot;read&quot; &lt; &quot;write&quot; &lt; &quot;delete&quot; &lt; &quot;edit&quot; &quot;GET&quot; &lt; &quot;POST&quot; &lt; &quot;DELETE&quot; &lt; &quot;PUT&quot; 1 &lt; 2 &lt; 3 &lt; 4","ref":"readme.html#guide","title":"SecureX - Guide","type":"extras"},{"doc":"In RestApi or GraphiQL all you have to do, add a Plug .","ref":"readme.html#middlewares","title":"SecureX - Middlewares","type":"extras"},{"doc":"#lib/plugs/securex_plug.ex defmodule MyApp.Plugs.SecureXPlug do @behaviour Plug import Plug.Conn def init ( default ) , do : default def call ( conn , _ ) do with [ &quot;Bearer &quot; &lt;&gt; token ] &lt;- get_req_header ( conn , &quot;authorization&quot; ) , { :ok , claims } &lt;- MyApp.Auth.Guardian . decode_and_verify ( token ) , { :ok , user } &lt;- MyApp.Auth.Guardian . resource_from_claims ( claims ) , { :ok , % Plug.Conn { } } &lt;- check_permissions ( conn , user ) do conn else { :error , error } -&gt; conn |&gt; put_resp_content_type ( &quot;application/json&quot; ) |&gt; send_resp ( 403 , Jason . encode! ( %{ errors : error } ) ) |&gt; Plug.Conn . halt ( ) _ -&gt; conn |&gt; put_resp_content_type ( &quot;application/json&quot; ) |&gt; send_resp ( 403 , Jason . encode! ( %{ errors : [ &quot;Permission Denied&quot; ] } ) ) |&gt; Plug.Conn . halt ( ) end end defp check_permissions ( %{ body_params : %{ &quot;resource&quot; =&gt; res , &quot;permission&quot; =&gt; permission } } = conn , %{ id : user_id } ) do case SecureX . has_access? ( user_id , res , permission ) do false -&gt; { :error , false } true -&gt; { :ok , conn } end end defp check_permissions ( _ , _ ) , do : { :error , [ &quot;Invalid Request&quot; ] } end You are all set. Please let us know about and open issue on https://github.com/DevWasi/secruex/issues Looking Forward to it. Happy Coding !!!!!","ref":"readme.html#examples","title":"SecureX - Examples","type":"extras"}]